﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.display.DisplayObject;
	import flash.events.MouseEvent;
	import com.as3facile.DefaultButton;
	import fl.motion.Color;
	import com.actionscriptfacile.ui.text.UITextField;

	import com.demonsters.debugger.MonsterDebugger;
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0x006f77")] 

	public class Main extends Sprite
	{

		private var oBackground : Sprite;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start  couleur aléatoire");
			
			this.buildUI();
		}


		/**
		 * Construit l'afficahge de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{
			// le sprite colorisé
			oBackground = new Sprite();
			oBackground.graphics.beginFill(0xffffff);// couleur du rectangle
			oBackground.graphics.drawRect(30, 30, stage.stageWidth - 60, stage.stageHeight - 60);// coordonnées x;y - largeur / hauteur
			oBackground.graphics.endFill();
			this.addChild(oBackground);


			// préparation d'une sortie Trace rapide pour l'application
			var oText:UITextField = this.addText("Cliquez ci-dessous pour changer la couleur du décor.");
			oText.x = (stage.stageWidth - oText.width) /2;
			oText.y = 50;
			this.addChild(oText);
			

			// Création du bouton
			var oBtnStartGame:DefaultButton = new DefaultButton();
			oBtnStartGame.getObject().label = "Nouvelle Couleur !";
			oBtnStartGame.getObject().x = (stage.stageWidth - oBtnStartGame.width) /2;;
			oBtnStartGame.getObject().y = oText.y + oText.height + 20;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onChangeColor );
			this.addChild(oBtnStartGame);
		}


		/**
		 * Appel lors du clic sur le bouton.
		 * 
		 */
		private function onChangeColor(event : MouseEvent) : void 
		{
			this.randomColor(oBackground);
		}
		
		

		/**
		 * Change aléatoirement la couleur d'un display object.
		 * 
		 */
		private function randomColor(oDisplay:DisplayObject) : void
		{
			MonsterDebugger.trace(this, "onColorChange");
			
			/**
			 * Toutes les infos sur
			 * http://help.adobe.com/fr_FR/FlashPlatform/reference/actionscript/3/fl/motion/Color.html
			 */
			var oRandColor:Color = new Color();  
			oRandColor.setTint(Math.random() * 0xFFFFFF, 1);// couleur aléatoire sur le Display Object 
			//oRandColor.setTint(0x006f77, 1); // code html pour choisir la couleur du Display Object - pourcentage pour la teinte de la couleur entre 0 et 1 
			  
			oDisplay.transform.colorTransform = oRandColor;  
		}
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 18);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		
	}
}
